routes/web.php
<?php

use App\Http\Controllers\Admin\UserController as AdminUserController;
use App\Http\Controllers\PlaceController;
use App\Http\Controllers\CommentController;
use App\Http\Controllers\UserController;
use App\Http\Livewire\Filter;
use App\Models\Categorie;
use App\Models\Place;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('home', ['places' => Place::all(), 'categories' => Categorie::all()]);
})->name('home');

// Route::get('/dashboard', function () {
//     return view('dashboard');
// })->middleware(['auth.banned', 'auth', 'auth.restricted'])->name('dashboard');



// PLACES
Route::get(
    '/places',
    [PlaceController::class, 'index'],
    // [PlaceController::class, 'viewByCat']
)->name('places');

Route::get(
    'components.Modal.addPlace',
    [PlaceController::class, 'showCategories']
)->name('showCategories');

Route::get(
    '/places/categories?category={id}',
    [PlaceController::class, 'viewByCat']
)->name('filterByCat');

Route::post(
    '/postPlace',
    [PlaceController::class, 'postPlace'] // nom de la fonction
)->middleware(['auth', 'checkPlaces'])->name('postPlace'); // nom de la route (qui sert à pointer vers une action d'un controller)

Route::get(
    '/place/{id}',
    [PlaceController::class, 'showPlace']
)->name('showPlace');

Route::get(
    '/categorie',
    [PlaceController::class, 'listCategories']
)->middleware(['auth'])->name('listCategories');

Route::post(
    '/updatePlace/{id}',
    [PlaceController::class, 'savePlace']
)->middleware(['auth'])->name('savePlace');

Route::get(
    '/deletePlace/{id}',
    [PlaceController::class, 'deletePlace']
)->middleware(['auth'])->name('deletePlace');

Route::get(
    '/updatePlace/{id}',
    [PlaceController::class, 'updatePlace']
)->middleware(['auth'])->name('updatePlace');

Route::post(
    '/',
    [PlaceController::class, 'addPlace']
)->middleware(['auth'])->name('addPlace');



// USERS
Route::get(
    '/user/{id}',
    [UserController::class, 'showUser']
)->middleware(['auth'])->name('showUser');

Route::get(
    '/updateInfos/{id}',
    [UserController::class, 'updateInfos']
)->middleware(['auth'])->name('updateInfos');

Route::post(
    '/updateInfos/{id}',
    [UserController::class, 'saveInfos']
)->middleware(['auth'])->name('saveInfos');

Route::get(
    '/destroy',
    [UserController::class, 'destroy']
)->middleware(['auth'])->name('destroy');



// COMMENTS
Route::post(
    '/postComment/{id}',
    [CommentController::class, 'postComment']
)->middleware(['auth'])->name('postComment');

Route::get(
    '/deleteComment/{id}',
    [CommentController::class, 'deleteComment']
)->middleware(['auth'])->name('deleteComment');

Route::get(
    '/updateComment/{id}/{idPlace}',
    [CommentController::class, 'updateComment']
)->middleware(['auth'])->name('updateComment');

Route::post(
    '/updateComment/{id}/{idPlace}',
    [CommentController::class, 'saveComment']
)->middleware(['auth'])->name('saveComment');


//ADMIN ROUTES
Route::prefix('admin')->middleware(['auth.banned', 'auth', 'auth.restricted'])
    ->name('admin.')->group(function () {
        Route::resource('/users', AdminUserController::class);
    });

require __DIR__ . '/auth.php';

app/Models/User.php
<?php

namespace App\Models;

use Illuminate\Contracts\Auth\MustVerifyEmail;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Foundation\Auth\User as Authenticatable;
use Illuminate\Notifications\Notifiable;
use Laravel\Sanctum\HasApiTokens;

class User extends Authenticatable
{
    use HasApiTokens, HasFactory, Notifiable;

    /**
     * The attributes that are mass assignable.
     *
     * @var array<int, string>
     */
    protected $fillable = [
        'name',
        'email',
        'password',
        'image',
    ];

    /**
     * The attributes that should be hidden for serialization.
     *
     * @var array<int, string>
     */
    protected $hidden = [
        'password',
        'remember_token',
    ];

    /**
     * The attributes that should be cast.
     *
     * @var array<string, string>
     */
    protected $casts = [
        'email_verified_at' => 'datetime',
        'is_banned' => 'boolean',
    ];

    public function roles()
    {
        return $this->belongsToMany(Role::class);
    }

    public function comments()
    {
        $this->hasMany(Comment::class);
    }

    /**
     * Check if a user has role
     * @param $role
     * @return bool
     */
    public function hasAnyRole(string $role)
    {
        return null !== $this->roles()->where('name', $role)->first();
    }
    /**
     * Check if a user has any given role
     * @param array $role
     * @return bool
     */
    public function hasAnyRoles(array $roles)
    {
        return null !== $this->roles()->whereIn('name', $roles)->first();
    }

    public function isBanned()
    {
        return $this->is_banned;
    }
}

app/Http/Controllers/Admin/UserController.php
<?php

namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;
use App\Http\Requests\StoreUserRequest;
use App\Models\Role;
use App\Models\User;
use App\Providers\RouteServiceProvider;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Gate;
use Illuminate\Support\Facades\Hash;
use Illuminate\Validation\Rules;

class UserController extends Controller
{

    // public function __construct()
    // {
    //     $this->authorizeResource(User::class);
    // }
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {

        $roles = Role::all();

        $users = User::paginate(10);

        if (Gate::allows('is_admin') || Gate::allows('is_manager')) {
            return view('admin.users.index', ['users' => $users, 'roles' => $roles]);
        }

        return redirect(RouteServiceProvider::HOME);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create(Request $request)
    {
        if (Gate::check('is_manager')) {
            $request->session()->flash('warning', 'Vous n\'êtes pas autorisé à effectuer cette action. Contacter un Administrateur');
            return redirect(route('admin.users.index'));
        }

        Gate::authorize('is_admin');

        $roles = Role::all();

        return view('admin.users.create', ['roles' => $roles]);
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(StoreUserRequest $request)
    {
        if (Gate::check('is_manager')) {
            $request->session()->flash('warning', 'Vous n\'êtes pas autorisé à effectuer cette action. Contacter un Administrateur');
            return redirect(route('admin.users.index'));
        }

        Gate::authorize('is_admin');

        $request->validated();

        $user = User::create([
            'name' => $request->name,
            'email' => $request->email,
            'image' => "rien",
            'password' => Hash::make($request->password),
        ]);

        $avatar = $request->image->getClientOriginalName();

        $request->image->storeAs('avatar', $avatar, 'public');

        $user->update(['image' => $avatar]);

        $user->roles()->sync($request->roles);

        $request->session()->flash('success', 'L\'utilisateur a bien été créé et va bientôt regréter');

        return redirect(route('admin.users.index'));
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit(string $id)
    {

        $user = User::findOrFail($id);

        $roles = Role::all();

        return view('admin.users.edit', ['user' => $user, 'roles' => $roles]);
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, string $id)
    {
        $user = User::find($id);
        // $user = User::findOrFail($id);

        if (!$user) {
            $request->session()->flash('error', 'Vous ne pouvez pas modifier les informations de cet utilisateur');
            return redirect(route('admin.users.index'));
        }

        $user->update($request->except(['_token', 'roles']));

        $user->roles()->sync($request->roles);

        $user->is_banned = $request->has('is_banned');

        $user->save();

        $request->session()->flash('success', 'Les informations de l\'utilisateur ont bien été misa à jour frère');

        return redirect(route('admin.users.index'));
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy(Request $request, string $id)
    {

        if (Gate::check('is_manager')) {
            $request->session()->flash('warning', 'Vous n\'êtes pas autorisé à effectuer cette action. Contacter un Administrateur');
            return redirect(route('admin.users.index'));
        }

        Gate::authorize('is_admin');

        $user = User::findOrFail($id);

        $user->roles()->detach();

        $user->destroy($id);

        $request->session()->flash('success', 'L\'utilisateur a été supprimé avec succès, rentre chez toi brooo');

        return redirect(route('admin.users.index'));
    }
}

app/Http/Controllers/UserController.php
<?php

namespace App\Http\Controllers;

use App\Models\Place;
use App\Models\User;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;

class UserController extends Controller
{
    public function showUser(Request $request)
    {
        $user = User::findOrFail($request->id);
        $places = Place::where('user_id', '=', Auth::id())->get();

        return view('user', ['user' => $user, 'places' => $places]);
    }

    public function updateInfos(Request $request) // injection de dépendant
    {
        // dd($id);
        $infos = User::find($request->id);
        return view('updateInfos', ['infos' => $infos]);
    }

    public function saveInfos(Request $request) // injection de dépendant
    {
        $infos = User::find($request->id);

        if ($request->hasFile('image')) {
            $filename = $request->image->getClientOriginalName();
            $request->image->storeAs('avatar', $filename, 'public');
        } else {
            $filename = $infos->image;
        }

        $infos->id = Auth::id();
        $infos->update(
            [
                $infos->image = $filename,
                $infos->name = $request->name,
                $infos->email = $request->email
            ]
        );

        return redirect()->route('showUser', ['id' => Auth::user()->id]);
    }

    public function destroy()
    {
        User::destroy(Auth::id());
        return redirect()->route('home');
    }
}

app/View/Components/AppLayout.php
<?php

namespace App\View\Components;

use Illuminate\View\Component;

class AppLayout extends Component
{
    /**
     * Get the view / contents that represents the component.
     *
     * @return \Illuminate\View\View
     */
    public function render()
    {
        return view('layouts.app');
    }
}

app/View/Components/GuestLayout.php
<?php

namespace App\View\Components;

use Illuminate\View\Component;

class GuestLayout extends Component
{
    /**
     * Get the view / contents that represents the component.
     *
     * @return \Illuminate\View\View
     */
    public function render()
    {
        return view('layouts.guest');
    }
}

resources/views/admin/users/create.blade.php
<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <meta name="csrf-token" content="{{ csrf_token() }}">

    <title>{{ config('app.name', 'Laravel') }}</title>

    <!-- Fonts -->
    <link rel="stylesheet" href="https://fonts.googleapis.com/css2?family=Nunito:wght@400;600;700&display=swap">

    <!-- Styles -->
    <link rel="stylesheet" href="{{ asset('css/app.css') }}">

    <!-- Scripts -->
    <script src="{{ asset('js/app.js') }}" defer></script>
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
</head>

<x-app-layout>
    <x-slot name="header">
        <h2 class="font-semibold cursor-pointer text-xl text-gray-800 leading-tight">
            <a href="{{ route('admin.users.index') }}"> {{ __('Tableau de bord d\'administration') }}</a>
        </h2>
        <p class="text-green-700 bold">
            {{ __('Ajout d\'un utilisateur') }}
        </p>
    </x-slot>

    <x-guest-layout>
        <x-auth-card>
            <x-slot name="logo">
                <a href="/">
                    <x-application-logo class="w-20 h-20 fill-current text-gray-500" />
                </a>
            </x-slot>

            <!-- Validation Errors -->
            <x-auth-validation-errors class="mb-4" :errors="$errors" />

            <form method="POST" action="{{ route('admin.users.store') }}" enctype="multipart/form-data">
                @csrf
                @method('POST')
                @include('admin.partials.form', ['create' => true])
            </form>
        </x-auth-card>
    </x-guest-layout>
</x-app-layout>

<script type="text/javascript">
    $(document).ready(function() {

        $("input[type=file]").on('change', function(input) {
            var file = $("input[type=file]").get(0).files[0];
            if (file) {
                var reader = new FileReader();
                reader.onload = function() {

                    $("#previewFile").css('background-image', "url(" + reader.result + ")");
                    $('.inputImage').addClass('invisible');
                    $('.deleteImage').removeClass('invisible');
                }
                reader.readAsDataURL(file);
            }
        });

        $(".deleteImage").on('click', function() {
            $("#previewFile").css('background-image', "none");
            $('.inputImage').removeClass('invisible');
            $('.deleteImage').addClass('invisible');
            $('#image').val("");
        });
    });
</script>

resources/views/admin/users/edit.blade.php
<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <meta name="csrf-token" content="{{ csrf_token() }}">

    <title>{{ config('app.name', 'Laravel') }}</title>

    <!-- Fonts -->
    <link rel="stylesheet" href="https://fonts.googleapis.com/css2?family=Nunito:wght@400;600;700&display=swap">

    <!-- Styles -->
    <link rel="stylesheet" href="{{ asset('css/app.css') }}">

    <!-- Scripts -->
    <script src="{{ asset('js/app.js') }}" defer></script>
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
</head>


<x-app-layout>
    <x-slot name="header">
        <h2 class="font-semibold cursor-pointer text-xl text-gray-800 leading-tight">
            <a href="{{ route('admin.users.index') }}"> {{ __('Tableau de bord d\'administration') }}</a>
        </h2>

        <p class="text-blue-400">
            {{ __('Mise à jour de l\'utilisateur') }} : {{ $user->id }}
        </p>
    </x-slot>

    <x-guest-layout>
        <x-auth-card class="full-width">
            <x-slot name="logo">
                <a href="/">
                    <x-application-logo class="w-20 h-20 fill-current text-gray-500" />
                </a>
            </x-slot>

            <!-- Validation Errors -->
            <x-auth-validation-errors class="mb-4" :errors="$errors" />

            <form method="POST" action="{{ route('admin.users.update', $user->id) }}" enctype="multipart/form-data">
                @csrf
                @method('PATCH')
                @include('admin.partials.form', ['create' => false])
            </form>
        </x-auth-card>
    </x-guest-layout>
</x-app-layout>

<script type="text/javascript">
    $(document).ready(function() {

        $("input[type=file]").on('change', function(input) {
            var file = $("input[type=file]").get(0).files[0];
            if (file) {
                var reader = new FileReader();
                reader.onload = function() {

                    $("#previewFile").css('background-image', "url(" + reader.result + ")");
                    $('.inputImage').addClass('invisible');
                    $('.deleteImage').removeClass('invisible');
                }
                reader.readAsDataURL(file);
            }
        });

        $(".deleteImage").on('click', function() {
            $("#previewFile").css('background-image', "none");
            $('.inputImage').removeClass('invisible');
            $('.deleteImage').addClass('invisible');
            $('#image').val("");
        });
    });
</script>

resources/views/admin/users/index.blade.php
<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <meta name="csrf-token" content="{{ csrf_token() }}">

    <title>{{ config('app.name', 'Laravel') }}</title>

    <!-- Fonts -->
    <link rel="stylesheet" href="https://fonts.googleapis.com/css2?family=Nunito:wght@400;600;700&display=swap">

    <!-- Styles -->
    <link rel="stylesheet" href="{{ asset('css/app.css') }}">

    <!-- Scripts -->
    <script src="{{ asset('js/app.js') }}" defer></script>
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
</head>

<x-app-layout>
    <x-slot name="header">
        <h2 class="font-semibold cursor-pointer text-xl text-gray-800 leading-tight">
            <a href="{{ route('admin.users.index') }}"> {{ __('Tableau de bord d\'administration') }}</a>
        </h2>
    </x-slot>

    <div class="py-12">
        <div class="max-w-7xl mx-auto sm:px-6 lg:px-8">
            <div class="bg-white overflow-hidden shadow-sm sm:rounded-lg">
                <div class="p-6 bg-white border-b border-gray-200 flex justify-between full-width items-center">
                    <h1>Listes des Utilisateurs</h1>
                    @can('is_admin')
                        <a class="text-white bg-green-600 cursor-pointer hover:bg-green-400 rounded border-none py-1 px-2"
                            href="{{ route('admin.users.create') }}" role="button">Créer un nouvel
                            utilisateur</a>
                    @endcan
                    @can('is_manager')
                        <a class="text-gray-300 cursor-pointer rounded border-none py-1 px-2"
                            href="{{ route('admin.users.create') }}" role="button">Créer un nouvel
                            utilisateur</a>
                    @endcan
                </div>
                <div class="text-gray-900 bg-gray-200">
                    <div class="px-3 py-4 flex justify-center flex-col">
                        <table class="w-full text-md bg-white shadow-md rounded mb-4">
                            <tbody>
                                <tr class="border-b">
                                    <th class="text-left p-3 px-5">n°Identifiant</th>
                                    <th class="text-left p-3 px-5">Prénom Nom</th>
                                    <th class="text-left p-3 px-5">Email</th>
                                    <th class="text-center p-3 px-5">Statut</th>
                                    <th class="text-center p-3 px-5">Rôles</th>
                                    <th class="text-left p-3 px-5">Actions</th>
                                    <th></th>
                                </tr>
                                @foreach ($users as $user)
                                    <tr class="border-b hover:bg-orange-100 bg-gray-100 py-4">
                                        <td class="text-center p-3 px-5">{{ $user->id }}_vpl</td>
                                        <td class="p-3 px-5">{{ $user->name }}</td>
                                        <td class="p-3 px-5">{{ $user->email }} </td>
                                        <td class="p-3 px-5">
                                            @if ($user->is_banned)
                                                <p
                                                    class="text-sm bg-red-500 hover:bg-red-700 text-white py-1 px-2 rounded text-center">
                                                    banni
                                                </p>
                                            @else
                                                <p class=" text-gray-600 text-center py-1 px-2">-</p>
                                            @endif
                                        </td>
                                        <td class="p-3 px-5">
                                            @foreach ($roles as $role)
                                                <div class="text-sm text-center">
                                                    @if (in_array($role->id, $user->roles->pluck('id')->toArray()))
                                                        {{ $role->name }}
                                                    @endif
                                                </div>
                                            @endforeach
                                        </td>
                                        <td class="p-3 px-5 flex justify-start">
                                            <a href="{{ route('admin.users.edit', $user->id) }}" role="button"
                                                class=" text-blue-600 text-sm py-1 px-2 rounded focus:outline-none focus:shadow-outline">modifier</a>
                                            @can('is_admin')
                                                <button type="button"
                                                    class="mr-3 text-red-800 text-sm  py-1 px-2 rounded focus:outline-none focus:shadow-outline"
                                                    onclick="event.preventDefault();document.getElementById('delete-user-form-{{ $user->id }}').submit()">supprimer</button>
                                            @endcan
                                            @can('is_manager')
                                                <button type="button"
                                                    class="mr-3 text-gray-300 text-sm  py-1 px-2 rounded focus:outline-none focus:shadow-outline"
                                                    onclick="event.preventDefault();document.getElementById('delete-user-form-{{ $user->id }}').submit()">supprimer</button>
                                            @endcan
                                            <form id="delete-user-form-{{ $user->id }}"
                                                action="{{ route('admin.users.destroy', $user->id) }}" method="POST"
                                                style="display: none">
                                                @csrf
                                                @method('DELETE')
                                            </form>

                                        </td>
                                    </tr>
                                @endforeach
                            </tbody>
                        </table>
                        <div class="user-pagination full-width flex justify-center items-center">
                            {{ $users->links() }}
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>

</x-app-layout>



<script>
    const paginationInfo = document.querySelector('.user-pagination nav :nth-child(2) div');
    paginationInfo.firstElementChild.style.display = "none";
</script>